/**  
    Version "@(#)$Header: /env/proj/archive/cvs/ioapi/./ioapi/src/daymonc.c,v 1.2 2000/11/27 22:54:25 smith_w Exp $"
    EDSS/Models-3 I/O API.  Copyright (C) 1992-1999 MCNC
    Distributed under the GNU LESSER GENERAL PUBLIC LICENSE version 2.1
    See file "LGPL.txt" for conditions of use.
**/

/**************************************************************************
PURPOSE
	Determines the month (1...12) and day of the month (1..31)
	for the Julian date YYYYDDD that is input

PRECONDITIONS

CALLS
	none

REVISION HISTORY
	prototype  3/95 by CJC
                    
**************************************************************************/

#include  "iodecl3.h"


void daymonc ( int jdate, int  *month, int  *mday )
    {
    int  year, day, j, k ;
     
    year = jdate / 1000 ;
    day  = jdate % 1000 ;
    k = ( year %   4 ) ? 365 :
        ( year % 100 ) ? 366 :
        ( year % 400 ) ? 365 : 366 ;
    j = ( day + 305 ) % k ;
    j = ( j % 153 ) / 61  +  2 * ( j / 153 )  +  j ;
    
    *month = ( j / 31 + 2 ) % 12  +  1 ;
    *mday  =   j % 31             +  1 ;

    }       /*  end body of daymonc()  */

