/**  
    Version "@(#)$Header: /env/proj/archive/cvs/ioapi/./ioapi/src/filchk3c.c,v 1.1 2000/11/27 22:54:18 smith_w Exp $"
    EDSS/Models-3 I/O API.  Copyright (C) 1992-1999 MCNC
    Distributed under the GNU LESSER GENERAL PUBLIC LICENSE version 2.1
    See file "LGPL.txt" for conditions of use.
**/

/**************************************************************************
C PURPOSE:
C	Checks to see whether file FNAME has the indicated type FTYPE,
C	and appropriate dimensions NCOLS, NROWS, NLAYS, NTHIK 
C	(with checking of just those that are appropriate for each FTYPE).
C	Layer-checking may be suppressed by setting NLAYS=ALLAYS3
C	C wrapper around Fortran-binding routine FILCHK3().
C	Returns TRUE iff the file is already open, and has the user-supplied
C	indicated file type and grid/array dimensions.
C
C PRECONDITIONS:
C	FNAME already opened by OPEN3() or open3c()
C
C CALLS:
C	Fortran I/O API's FILCHK3()
C
C REVISION HISTORY:
C	Prototype 10/2000 by CJC
**************************************************************************/

#include  <string.h>
#include  "iodecl3.h"


		/** HACKS FOR FELDMAN-DESCENDED F77'S FOLLOW: **/

#if FLDMN

#define FILCHK3 FILCHK3_

#elif defined(__hpux) || defined(_AIX)

#define FILCHK3 FILCHK3

#endif


#if defined(FILCHK3) || defined(_WIN32 )

    extern int FILCHK3( const char *fname ,
                        const int  *ftype ,
                        const int  *ncols ,
                        const int  *nrows ,
                        const int  *nlays ,
                        const int  *nthik ,
                        const int   fnamlen ) ;

int filchk3c( const char * fname ,
              const int    ftype ,
              const int    ncols ,
              const int    nrows ,
              const int    nlays ,
              const int    nthik )

    {
    return( FILCHK3( fname , 
                    &ftype , &ncols , &nrows , &nlays , &nthik ,
                    strlen( fname ) ) ) ;
    }

                	/** END  CASE OF FELDMAN-DESCENDED F77 TARGETS **/
                	/** NEXT CASE:  CRAY CF77-TARGETED filchk3c(): **/


#elif  defined(_CRAY)


#include <fortran.h>

    extern int FILCHK3( const _fcd   fname,
                        const int   *ftype ,
                        const int   *ncols ,
                        const int   *nrows ,
                        const int   *nlays ,
                        const int   *nthik ) ;

int filchk3c( const char * fname ,
              const int    ftype ,
              const int    ncols ,
              const int    nrows ,
              const int    nlays ,
              const int    nthik )

    {
    
    _fcd  file ;
    
    file = _cptofcd( (char *)fname, strlen( fname ) ) ;

    return ( _btol( FILCHK3( file , 
                    &ftype , &ncols , &nrows , &nlays , &nthik ) ) ) ;
    }

                	/** END  CASE OF CRAY CF77-TARGETED filchk3c(): **/

#else

#error   "Error compiling filchk3c():  unsupported architecture"

#endif              /** IF FELDMAN-DESCENDED F77 TARGETED, OR IF CRAY **/

