/**
  * @(#)$Header: /env/proj/archive/cvs/ioapi/./ioapi/src/iocplf2c.m4,v 1.2 2000/11/28 22:17:41 smith_w Exp $
 **/
#include <string.h>
#include <setjmp.h>
#include "fdesc3.h"

#define MAX_STR_LEN 256
#define FALSE 0

typedef int Integer;
typedef long Logical;

jmp_buf saved_env;

/* =========================================================== */
/* =========================================================== */

IOAPI_Bdesc3 *get_bdesc3f()
{

  extern IOAPI_Bdesc3 FUNCTION(bdesc3);
  IOAPI_Bdesc3 *bdesc3p = &FUNCTION(bdesc3);

  return (bdesc3p);

}
/* =========================================================== */
IOAPI_Cdesc3 *get_cdesc3f()
{

  extern IOAPI_Cdesc3 FUNCTION(cdesc3);
  IOAPI_Cdesc3 *cdesc3p = &FUNCTION(cdesc3);

  return (cdesc3p);

}
/* =========================================================== */
/* =========================================================== */
/*
int f2cstring(char *cstr, char *fstr, int len)
{
  strncpy(cstr, fstr, len);
  cstr[len]='\0';

  return 1;
}
*/
#ifndef min
#define min(i,j) ((i)<(j)?(i):(j))
#endif


int f2cstring(ds, ss, len)
    char *ds, *ss;      /* dst, src ptrs */
    int len;             /* src len */
{
    char *p;
    int dl = MAX_STR_LEN;

    for (p = ss + len; --p >= ss && *p == ' '; ) ;
    len = p - ss + 1;
    dl--;
    ds[0] = 0;
    if (len > dl)
        return 1;
    strncat(ds, ss, min(len, dl));
    return 0;
}

/* =========================================================== */

Logical FUNCTION(open3v)
     ARGS(`STRING_ARG(fname), mode, STRING_ARG(pgmname)')
  STRING_ARG_DECL(fname);  
  STRING_ARG_DECL(pgmname);  
  Integer *mode;
{

  int filemode=*mode;
  char name[MAX_STR_LEN];
  char pgm[MAX_STR_LEN];
  IOAPI_Bdesc3 *get_bdesc3f();
  IOAPI_Cdesc3 *get_cdesc3f();
  IOAPI_Bdesc3 *bdesc3p;
  IOAPI_Cdesc3 *cdesc3p;
  char *trim;


  f2cstring(name, STRING_PTR(fname), STRING_LEN(fname));
  f2cstring(pgm, STRING_PTR(pgmname), STRING_LEN(pgmname));
  trim = strrchr(pgm,'/');
  
  bdesc3p=get_bdesc3f();
  cdesc3p=get_cdesc3f();

  if (setjmp(saved_env) != 0) {
    return FALSE;
  }
  return open3net(name, bdesc3p, cdesc3p, filemode, (trim ? trim+1:pgm));
}

/* =========================================================== */

Logical FUNCTION(desc3v)
     ARGS(`STRING_ARG(fname)')
  STRING_ARG_DECL(fname);  
{

  char name[MAX_STR_LEN];
  IOAPI_Bdesc3 *get_bdesc3f();
  IOAPI_Cdesc3 *get_cdesc3f();
  IOAPI_Bdesc3 *bdesc3p;
  IOAPI_Cdesc3 *cdesc3p;


  f2cstring(name, STRING_PTR(fname), STRING_LEN(fname));
  
  bdesc3p=get_bdesc3f();
  cdesc3p=get_cdesc3f();

  if (setjmp(saved_env) != 0) {
    return FALSE;
  }
  return desc3net(name, bdesc3p, cdesc3p);
}

/* =========================================================== */
Logical FUNCTION(shut3v_st)
     ARGS(`void')
{
  if (setjmp(saved_env) != 0) {
    return FALSE;
  }
  return shut3net();
}

/* =========================================================== */

Logical FUNCTION(read3v_st)
     ARGS(`STRING_ARG(fname),STRING_ARG(vname),
	  iskip,jdate,jtime,buffer,icount,ftype')
  STRING_ARG_DECL(fname);  
  STRING_ARG_DECL(vname);
  Integer *iskip;
  Integer *jdate;
  Integer *jtime;
  Integer *icount;
  Integer *ftype;
  void *buffer;
{
  int skip=*iskip;
  int date=*jdate;
  int time=*jtime;
  int count=*icount;
  int type=*ftype;
  char fnm[MAX_STR_LEN], vnm[MAX_STR_LEN];

  f2cstring(fnm, STRING_PTR(fname), STRING_LEN(fname));
  f2cstring(vnm, STRING_PTR(vname), STRING_LEN(vname));

  if (setjmp(saved_env) != 0) {
    return FALSE;
  }
  return read3net(fnm,vnm,skip,date,time,buffer,count,type);
}

/* =========================================================== */

Logical FUNCTION(write3v_st)
     ARGS(`STRING_ARG(fname),STRING_ARG(vname),
	  jdate,jtime,buffer,icount,ftype')
  STRING_ARG_DECL(fname);  
  STRING_ARG_DECL(vname);
  Integer *jdate;
  Integer *jtime;
  Integer *icount;
  Integer *ftype;
  void *buffer;
{

  int date=*jdate;
  int time=*jtime;
  int count=*icount;
  int type=*ftype;
  char fnm[MAX_STR_LEN], vnm[MAX_STR_LEN];

  f2cstring(fnm, STRING_PTR(fname), STRING_LEN(fname));
  f2cstring(vnm, STRING_PTR(vname), STRING_LEN(vname));

  if (setjmp(saved_env) != 0) {
    return FALSE;
  }
  return write3net(fnm,vnm,date,time,buffer,count,type);
}

/* =========================================================== */

void FUNCTION(get_iocpl_version)
     ARGS(`STRING_ARG(vers)')
  STRING_ARG_DECL(vers);  
{
  extern char *iocpl_version();
  char *version, *Ftrn_str;
  int i, len;

  Ftrn_str = STRING_PTR(vers); 
  len = STRING_LEN(vers);
  /* fill the Fortran string with blanks */
  for (i=0; i< len; i++) {
    Ftrn_str[i] = ' ';
  }

  version = iocpl_version();
  strncpy(Ftrn_str, version, min(len,strlen(version)));
}

/* =========================================================== */

void FUNCTION(get_pvm_version)
     ARGS(`STRING_ARG(vers)')
  STRING_ARG_DECL(vers);  
{
  extern char *pvm_version();
  char *version, *Ftrn_str;
  int i, len;

  Ftrn_str = STRING_PTR(vers); 
  len = STRING_LEN(vers);
  /* fill the Fortran string with blanks */
  for (i=0; i< len; i++) {
    Ftrn_str[i] = ' ';
  }

  version = pvm_version();
  strncpy(Ftrn_str, version, min(len,strlen(version)));
}

/* =========================================================== */

void FUNCTION(setsynchro3v)
     ARGS(newvalue)
   Integer *newvalue;
{
  int new_value=*newvalue;
  void setWaitForSynchro(int);


  setWaitForSynchro(new_value);
}

/* =========================================================== */
/* =========================================================== */
/* =========================================================== */
/* =========================================================== */
/* =========================================================== */
/* =========================================================== */
