
C.........................................................................
C Version "@(#)$Header: /env/proj/archive/cvs/ioapi/./ioapi/src/julian.f,v 1.2 2000/11/28 21:22:51 smith_w Exp $"
C EDSS/Models-3 I/O API.  Copyright (C) 1992-1999 MCNC
C Distributed under the GNU LESSER GENERAL PUBLIC LICENSE version 2.1
C See file "LGPL.txt" for conditions of use.
C.........................................................................

      INTEGER FUNCTION JULIAN (YEAR, MNTH, MDAY)

C***********************************************************************
C  function body starts at line  50
C
C  FUNCTION:  returns the Julian day (1...365,366) corresponding to
C      the date MNTH-MDAY-YEAR.
C      NOTE:  This is NOT the Julian DATE -- only the
C      day-number.  To get the Julian date:
C
C      JDATE = 1000 * YEAR  +  JULIAN ( YEAR , MNTH , MDAY )
C
C  REVISION HISTORY:
C
C    5/88   Modified for ROMNET
C    8/90   Modified for ROM 2.2:  improved comments; improved algorithm
C           using IF-THEN ... ELSE IF ... construction.
C
C  ARGUMENT LIST DESCRIPTION:
C
C    Input arguments:
C
C      YEAR     Calendar year
C      MNTH     Month of year  1, 12
C      MDAY     Day of month   1, 31
C
C     Output arguments:  none
C
C  RETURN VALUE:
C
C      JULIAN   The Julian DAY of the input arguments combined
C
C  LOCAL VARIABLE DESCRIPTION:
C
C
C***********************************************************************

      IMPLICIT NONE

      INTEGER   YEAR, MNTH, MDAY, M, N, L

      M = MOD ((MNTH + 9), 12)
      N = (M * 153 + 2) / 5 + MDAY + 58

      IF (MOD (YEAR, 4) .NE. 0) THEN
          L = 365
      ELSE IF (MOD (YEAR, 100) .NE. 0) THEN
          L = 366
          N = 1 + N
      ELSE IF (MOD (YEAR, 400) .NE. 0)  THEN
          L = 365
      ELSE 
          L = 366
          N = 1 + N
      END IF

      JULIAN = 1 + MOD (N, L)

      RETURN
      END

