#!/bin/csh -f
# @(#)$Header: /env/proj/archive/cvs/ioapi/./ioapi/src/link_to_includes.csh,v 1.1 2000/12/13 19:28:01 smith_w Exp $
#
# When compiling source code that uses the IOAPI, you need the source for the
# IOAPI include files.  You typically want to have symbolic links in the directory
# where you are compiling to the actual include files.  You execute this script
# from the directory that contains the include files.  You specify as input the
# directory where you will be compiling.  The script inserts a symbolic link
# to each *.h and *.EXT file into the compiling directory.
#set echo
set com = $0
if ( $#argv < 1 ) then
   echo ""
   echo "Usage: ${com:t} <dir where compiling>"
   echo ""
   exit 1
   endif
set compile_dir = $argv[1]
if ( ! -d $compile_dir ) then
   echo ""
   echo "### ${com:t}: Cannot find directory."
   echo "    $compile_dir"
   exit 2
   endif
set include_dir_abs = $cwd
set includes = ( *.h *.EXT )
set compile_dir_abs = (`cd $compile_dir; pwd`)
cd $compile_dir_abs
echo ""
echo "Inserting symbolic links into directory ..."
echo "  $compile_dir_abs"
foreach f ( $includes )
if ( -f $f ) then
# A file already exists with this name.  It may not be a symbolic link.
   set is_link = "`find $f -type l -print`"
   if ( $f == $is_link) then
      /bin/rm $f
      echo ""
      echo "Replacing symbolic link for $f"
      ln -s $include_dir_abs/$f $f
      else
      echo ""
      echo "### Cannot create symbolic link for $f."
      echo "    A plain file already exist with that name."   
      endif
   else
#  The symbolic file does not exist, so create it.
   echo ""
   echo "Creating symbolic link for $f"
   ln -s $include_dir_abs/$f $f
   endif
end   
exit 0

