
C.........................................................................
C Version "@(#)$Header: /env/proj/archive/cvs/ioapi/./ioapi/src/m3abort.F,v 1.3 2000/11/28 21:13:40 smith_w Exp $"
C EDSS/Models-3 I/O API.  Copyright (C) 1992-1999 MCNC
C Distributed under the GNU LESSER GENERAL PUBLIC LICENSE version 2.1
C See file "LGPL.txt" for conditions of use.
C.........................................................................

        SUBROUTINE  M3ABORT( FNAME, FNUM, IERR, MESSAGE )

C***********************************************************************
C  subroutine body starts at line  47
C
C  FUNCTION:  
C       Generate complex netCDF-related messages for I/O API,
C       and call NCABOR() on the related file
C
C  PRECONDITIONS REQUIRED:  
C       message fits on one line
C       netCDF 3.x or later
C
C  SUBROUTINES AND FUNCTIONS CALLED:  INIT3, TRIMLEN, NF_STRERROR
C
C  REVISION  HISTORY:   
C       Adapted  9/99 by CJC from M3MESG()
C       Modified 9/99 by CJC for AIX "flush_"
C***********************************************************************

      IMPLICIT NONE

#ifdef   _AIX
#define  FLUSH flush_
#endif

C...........   INCLUDES:

        INCLUDE 'IODECL3.EXT'
        INCLUDE 'NETCDF.EXT'


C...........   ARGUMENT and its description:

        CHARACTER*(*)   FNAME           !  file name
        INTEGER         FNUM            !  netCDF file ID
        INTEGER         IERR            !  netCDF error number
        CHARACTER*(*)   MESSAGE

                 
C...........   EXTERNAL FUNCTIONS and their descriptions:

        INTEGER  TRIMLEN  !  string length, exclusive of trailing blanks
        EXTERNAL TRIMLEN


C...........   SAVED LOCAL VARIABLES and their descriptions:

        INTEGER         LOGDEV
        DATA            LOGDEV / -1 /
        SAVE            LOGDEV

C.......   Scratch LOCAL VARIABLES

        INTEGER	        L, M
        CHARACTER*80    MESG       !  fixed-length buffer


C***********************************************************************
C   begin body of subroutine  M3MSG2

!$OMP CRITICAL( S_LOGDEV )
        IF ( LOGDEV .LT. 0 ) LOGDEV = INIT3()

        L = TRIMLEN( MESSAGE )
        WRITE( LOGDEV,92010 ) MESSAGE( 1:L )
        WRITE( LOGDEV,92010 ) 
     &          'netCDF error number', IERR, 
     &          'processing file "', FNAME( 1:TRIMLEN( FNAME ) ), '"'
        MESG = NF_STRERROR( IERR)
        M = TRIMLEN( MESG )
        WRITE( LOGDEV,92010 ) MESG( 1:M )

	CALL FLUSH( LOGDEV )

#ifndef IOAPI_NO_STDOUT
        IF ( LOGDEV .NE. 6 ) THEN
            WRITE( *,92010 ) MESSAGE( 1:L )
            WRITE( *,92010 ) 
     &          'netCDF error number', IERR, 
     &          'processing file "', FNAME( 1:TRIMLEN( FNAME ) ), '"'
            WRITE( LOGDEV,92010 ) MESG( 1:M )
	    CALL FLUSH( 6 )
        END IF		!  if logdev is not pointing at standard output

        CALL NCABOR( FNUM, IERR )
        IF ( IERR .NE. 0 ) THEN
        END IF
#endif

!$OMP END CRITICAL( S_LOGDEV )

        RETURN

C******************  FORMAT  STATEMENTS   ******************************

C...........   Log message formats..... 92xxx

92010   FORMAT ( 5X , A, :, I5, :, 2X, 3A )

        END

