/**  
    Version "@(#)$Header$"
    EDSS/Models-3 I/O API.  Copyright (C) 1992-2002 MCNC
    Distributed under the GNU LESSER GENERAL PUBLIC LICENSE version 2.1
    See file "LGPL.txt" for conditions of use.
**/

/**************************************************************************
C PURPOSE:
C	Performs disk-synchronization for netCDF-based file FNAME.
C       Wrapper around I/O API Fortran-binding routines SYNC3().
C
C PRECONDITIONS:
C	FNAME already opened by OPEN3() or open3c()
C
C CALLS:
C	Fortran I/O API's SYNC3()
C
C REVISION HISTORY:
C	Prototype 1/2002 by C
**************************************************************************/

#include  <string.h>
#include  "iodecl3.h"


		/** HACKS FOR FELDMAN-DESCENDED FC'S FOLLOW: **/

#if FLDMN

#define SYNC3 sync3_

#elif defined(__hpux) || defined(_AIX)

#define SYNC3 sync3

#endif


#if defined(SYNC3)

    extern int SYNC3( const char * fname , int fnamelen ) ;


int sync3c( const char * fname )

    {
    return( SYNC3( fname , (int) strlen( fname ) ) ;
    }


                	/** END  CASE OF FELDMAN-DESCENDED F77 TARGETS **/
                	/** NEXT CASE:  Win32 sync3c(): **/

#elif defined(_WIN32)

#include <stdio.h> /* for sprintf */

    extern int SYNC3( const char * fname , int fnamelen ) ;


int sync3c( const char * fname )

    {
    return( SYNC3( fname , (int) strlen( fname ) ) ;
    }


                	/** END  CASE OF Win32 **/
                	/** NEXT CASE:  CRAY-TARGETED sync3c(): **/

#elif  defined(_CRAY)   /** treatment:  CRAY arryas of strings?? **/


#include <fortran.h>

    extern int SYNC3( const _fcd   fname  ) ;


int sync3c( const char * fname  )

    {
    _fcd  file ;

    file = _cptofcd( (char *)fname, (int) strlen( fname ) ) ;

    return( _btol( SYNC3( file ) ) ) ;
    } 

#else

#error   "Error compiling sync3c():  unsupported architecture"

#endif              /** IF FELDMAN-DESCENDED "FC" TARGETED, 
                        OR IF Win32, OR IF CRAY **/



